// Copyright 1998-1999 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.

#import "OAIAnalysis.h"
#import "OAICorpus.h"
#import <AIAT/AlphaTokenizer.h>
#import <AIAT/DocTextCharStream.h>
#import <AIAT/DowncaseFilter.h>
#import <AIAT/ShortWordFilter.h>
#import <AIAT/StringTerm.h>
#import <AIAT/AlphaTokenizer.h>

extern "C" {
    #import <OmniBase/rcsid.h>
    #import <Foundation/Foundation.h>
    #import "OAITokenizerRegistry.h"
}

RCS_ID("$Header: /Network/Developer/Source/CVS/OmniGroup/OmniAIAT/OAIAnalysis.M,v 1.4 1999/04/12 19:32:52 kc Exp $")

IATokenStream *OAIAnalysis::MakeTokenStream(IADocText *text)
{
    OAIDocText *realText;
    DocTextCharStream *stream;
    IATokenStream *tokenizer;
    IATokenStream *result;
    NSAutoreleasePool *pool;

    pool = [[NSAutoreleasePool alloc] init];
    stream = new DocTextCharStream(text);
    realText = (OAIDocText *)text;
    tokenizer = [[OAITokenizerRegistry sharedRegistry] tokenizerForExtension:(NSString *)realText->GetExtension() withStream:stream];

    if (!tokenizer)
        result = new DowncaseFilter(new ShortWordFilter(new AlphaTokenizer(stream)));
    else
        result = new DowncaseFilter(new ShortWordFilter(tokenizer));
    [pool release];
    return result;
}

IATerm *OAIAnalysis::GetProtoTerm()
{
    return new StringTerm("");
}
