// Copyright 1998-1999 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Developer/Source/CVS/OmniGroup/OmniAIAT/OAICorpus.h,v 1.4 1999/04/12 19:32:53 kc Exp $

#import <AIAT/UFSDirectoryCorpus.h>
#import <AIAT/UFSCorpus.h>

class OAIDocIterator : public IADocIterator {
public:
    OAIDocIterator(IADocIterator *originalIterator);
    ~OAIDocIterator();

    IADoc* GetNextDoc();
private:
    IADocIterator *original;
};

class OAICorpus : public UFSDirectoryCorpus {
public:
    OAICorpus(const byte *rootDirPath) : UFSDirectoryCorpus(rootDirPath) {}
    IADocIterator* GetDocIterator();
    IADocText* GetDocText(const IADoc *doc);
};

class OAIDocText : public UFSDocText {
public:
    OAIDocText(const byte *path);
    ~OAIDocText();
    
    void *GetExtension();
private:
    void *extension;
};