// Copyright 1998-1999 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.

extern "C" {
    #import "OAIIndex.h"
}

#import <Foundation/Foundation.h>
#import <AIAT/UFSStorage.h>
#import <AIAT/InvertedIndex.h>
#import <AIAT/InvertedAccessor.h>
#import <AIAT/UFSDirectoryCorpus.h>
#import <AIAT/SimpleAnalysis.h>
#import <AIAT/IAAccessor.h>
#import <AIAT/IACorpus.h>
#import <OmniBase/rcsid.h>

#import "OAICorpus.h"
#import "OAIAnalysis.h"

RCS_ID("$Header: /Network/Developer/Source/CVS/OmniGroup/OmniAIAT/OAIIndex.M,v 1.5 1999/04/12 19:32:53 kc Exp $")

@implementation OAIIndex

// Init and dealloc

- initNewIndex:(NSString *)filename forDirectory:(NSString *)directory;
{
    if (![super init])
        return nil;

    storage = MakeFileStorage([filename cString]);
    ((IAStorage *)storage)->Initialize();
    index = new InvertedIndex((IAStorage *)storage, new OAICorpus((const byte *)[directory cString]), new OAIAnalysis());
    ((InvertedIndex *)index)->Initialize();

    return self;
}

- initWithIndex:(NSString *)filename forDirectory:(NSString *)directory;
{
    if (![super init])
        return nil;

    storage = MakeFileStorage([filename cString]);
    ((IAStorage *)storage)->Open(true);
    index = new InvertedIndex((IAStorage *)storage, new OAICorpus((const byte *)[directory cString]), new OAIAnalysis());
    ((InvertedIndex *)index)->Open();

    return self;
}

- (void)dealloc;
{
    delete (InvertedIndex *)index;
    delete (IAStorage *)storage;
    [super dealloc];
}

// API

- (void)update;
{
    ((InvertedIndex *)index)->Update();
    ((InvertedIndex *)index)->Compact();
    ((IAStorage *)storage)->Commit();
}

- (void *)indexObject;
{
    return index;
}

@end
