// Copyright 1998-1999 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.

#import "OAIObjCTokenizer.h"

extern "C" {
    #import <OmniBase/rcsid.h>
};

RCS_ID("$Header: /Network/Developer/Source/CVS/OmniGroup/OmniAIAT/OAIObjCTokenizer.M,v 1.6 1999/04/12 19:32:53 kc Exp $")

OAIObjCTokenizer::OAIObjCTokenizer(id <OAITokenizerInstance> objCObject)
{
    tokenizer = [objCObject retain];
    tokenArray = [[NSMutableArray alloc] init];
}

OAIObjCTokenizer::~OAIObjCTokenizer()
{
    [tokenizer release];
    [tokenArray release];
}

IAToken *OAIObjCTokenizer::GetNextToken()
{
    NSString *string;
    static unsigned int index = 0;

    string = [tokenizer nextToken];
    if (string) {
        IAToken *token;
        unsigned int stringLength;

        stringLength = [string cStringLength];
        // token = new IAToken(new IATerm((const unsigned char *)[string cString], (long unsigned int)[string cStringLength]), index, index+1);
        token = new IAToken(new StringTerm([string cString]), index, index + stringLength);
        index += stringLength + 1;
        [tokenArray addObject:string];
        return token;
    }
    return NULL;
}

void OAIObjCTokenizer::GetTextSpan(byte *dest, uint32 startPos, uint32 endPos)
{
    NSString *string;

    string = [tokenArray objectAtIndex:startPos];
    [string getCString:(char *)dest];
}

