// Copyright 1998-1999 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.

extern "C" {
    #import "OAIObjCTokenizerHolder.h"
    #import "OAIStringScanner.h"
    #import <OmniBase/rcsid.h>
}

RCS_ID("$Header: /Network/Developer/Source/CVS/OmniGroup/OmniAIAT/OAIObjCTokenizerHolder.M,v 1.4 1999/04/12 19:32:53 kc Exp $")

#import "OAIObjCTokenizer.h"

@implementation OAIObjCTokenizerHolder

- initWithFactory:(id <OAITokenizer>)factory;
{
    if (!(self = [super init]))
        return nil;

    tokenizerFactory = [factory retain];

    return self;
}

- (void)dealloc;
{
    [tokenizerFactory release];
    [super dealloc];
}

- (void *)cppTokenizerForStream:(void *)stream;
{
    OAIStringScanner *scanner;
    OAIObjCTokenizer *tokenizer;

    scanner = [[OAIStringScanner alloc] initWithStream:stream];
    tokenizer = new OAIObjCTokenizer([tokenizerFactory tokenizerForScanner:scanner]);
    [scanner release];
    return tokenizer;
}

@end
