// Copyright 1998-1999 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.


extern "C" {
    #import "OAIStringScanner.h"
    #import <OmniBase/rcsid.h>
    #import <Foundation/Foundation.h>
}

#import <AIAT/DocTextCharStream.h>

RCS_ID("$Header: /Network/Developer/Source/CVS/OmniGroup/OmniAIAT/OAIStringScanner.M,v 1.2 1999/04/12 19:32:54 kc Exp $")

@implementation OAIStringScanner

- initWithStream:(void *)aStream;
{
    [super init];
    stream = aStream;
    return self;
}

- (void)dealloc;
{
    delete (DocTextCharStream *)stream;
    [super dealloc];
}

#define BUFFER_LENGTH  8192

- (BOOL)fetchMoreData;
{
    DocTextCharStream *realStream = (DocTextCharStream *)stream;
    char buffer[BUFFER_LENGTH];
    unichar *result, *resultPtr;
    char *ptr, *end;
    unsigned int length;

    length = realStream->GetNextBuffer(buffer, BUFFER_LENGTH);
    if (!length)
        return NO;
    result = NSZoneMalloc(NULL, length * sizeof(unichar));
    ptr = buffer;
    end = buffer + length;
    resultPtr = result;
    while(ptr < end)
        *resultPtr++ = *ptr++;
    return [self fetchMoreDataFromCharacters:result length:length freeWhenDone:YES];
}

@end
