// Copyright 1998-1999 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Developer/Source/CVS/OmniGroup/OmniAIAT/OAITokenizerRegistry.h,v 1.7 1999/04/12 19:32:54 kc Exp $

#import <Foundation/NSObject.h>

@class NSMutableDictionary;

#import "OAITokenizerProtocol.h"

@interface OAITokenizerRegistry : NSObject
{
    NSMutableDictionary *tokenizers;
    NSMutableDictionary *bundleInformation;
    NSMutableDictionary *typeToBundle;
}

+ (OAITokenizerRegistry *)sharedRegistry;

- (void)registerTokenizer:(id <OAITokenizer>)aTokenizer forExtension:(NSString *)extension;
- (void)unregisterTokenizerForExtension:(NSString *)extension;
- (void)registerDefaultTokenizers;

- (BOOL)hasTokenizerForExtension:(NSString *)extension;
- (void *)tokenizerForExtension:(NSString *)extension withStream:(void *)stream;


@end
